| AAX SDK 2.6.1 Avid Audio Extensions Development Kit

- Welcome
- Manual
- Classes
- Files
- Lists
- Support

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
List of all members | Public Member Functions
AAX_CEffectParameters Class Reference
AAX SDK Manual » Core AAX Interface » Data model interface

`#include <AAX_CEffectParameters.h>`

Inheritance diagram for AAX_CEffectParameters:
[legend]
Collaboration diagram for AAX_CEffectParameters:
[legend]

## Description

Default implementation of the AAX_IEffectParameters interface.

This class provides a default implementation of the AAX_IEffectParameters interface. In nearly all cases, your plug-in's data model should inherit from this class and override only those functions that you wish to explicitly customize.

Legacy Porting Notes:
  The default implementations in this class are mostly derived from their equivalent implementations in CProcess and CEffectProcess. For additional CProcess-derived implementations, see AAX_CEffectGUI.

# Related classes

Classes related to AAX_IEffectParameters by inheritance or composition
Classes owned as member objects of AAX_CEffectParameters

## Public Member Functions
| AAX_CEffectParameters (void)
| ~AAX_CEffectParameters (void) AAX_OVERRIDE
AAX_CEffectParameters & | operator= (const AAX_CEffectParameters &other)
Initialization and uninitialization
AAX_Result | Initialize (IACFUnknown *iController) AAX_OVERRIDE
| Main data model initialization. Called when plug-in instance is first instantiated.
AAX_Result | Uninitialize (void) AAX_OVERRIDE
| Main data model uninitialization.
AAX host and plug-in event notification
AAX_Result | NotificationReceived (AAX_CTypeID inNotificationType, const void *inNotificationData, uint32_t inNotificationDataSize) AAX_OVERRIDE
| Notification Hook.
Parameter information
These methods are used by the AAX host to retrieve information about the plug-in's data model. For information about adding parameters to the plug-in and otherwise modifying the plug-in's data model, see AAX_CParameterManager. For information about parameters, see AAX_IParameter.
AAX_Result | GetNumberOfParameters (int32_t *oNumControls) const AAX_OVERRIDE
| CALL: Retrieves the total number of plug-in parameters.
AAX_Result | GetMasterBypassParameter (AAX_IString *oIDString) const AAX_OVERRIDE
| CALL: Retrieves the ID of the plug-in's Master Bypass parameter.
AAX_Result | GetParameterIsAutomatable (AAX_CParamID iParameterID, AAX_CBoolean *oAutomatable) const AAX_OVERRIDE
| CALL: Retrieves information about a parameter's automatable status.
AAX_Result | GetParameterNumberOfSteps (AAX_CParamID iParameterID, int32_t *oNumSteps) const AAX_OVERRIDE
| CALL: Retrieves the number of discrete steps for a parameter.
AAX_Result | GetParameterName (AAX_CParamID iParameterID, AAX_IString *oName) const AAX_OVERRIDE
| CALL: Retrieves the full name for a parameter.
AAX_Result | GetParameterNameOfLength (AAX_CParamID iParameterID, AAX_IString *oName, int32_t iNameLength) const AAX_OVERRIDE
| CALL: Retrieves an abbreviated name for a parameter.
AAX_Result | GetParameterDefaultNormalizedValue (AAX_CParamID iParameterID, double *oValue) const AAX_OVERRIDE
| CALL: Retrieves default value of a parameter.
AAX_Result | SetParameterDefaultNormalizedValue (AAX_CParamID iParameterID, double iValue) AAX_OVERRIDE
| CALL: Sets the default value of a parameter.
AAX_Result | GetParameterType (AAX_CParamID iParameterID, AAX_EParameterType *oParameterType) const AAX_OVERRIDE
| CALL: Retrieves the type of a parameter.
AAX_Result | GetParameterOrientation (AAX_CParamID iParameterID, AAX_EParameterOrientation *oParameterOrientation) const AAX_OVERRIDE
| CALL: Retrieves the orientation that should be applied to a parameter's controls.
AAX_Result | GetParameter (AAX_CParamID iParameterID, AAX_IParameter **oParameter) AAX_OVERRIDE
| CALL: Retrieves an arbitrary setting within a parameter.
AAX_Result | GetParameterIndex (AAX_CParamID iParameterID, int32_t *oControlIndex) const AAX_OVERRIDE
| CALL: Retrieves the index of a parameter.
AAX_Result | GetParameterIDFromIndex (int32_t iControlIndex, AAX_IString *oParameterIDString) const AAX_OVERRIDE
| CALL: Retrieves the ID of a parameter.
AAX_Result | GetParameterValueInfo (AAX_CParamID iParameterID, int32_t iSelector, int32_t *oValue) const AAX_OVERRIDE
| CALL: Retrieves a property of a parameter.
Parameter setters and getters
These methods are used by the AAX host and by the plug-in's UI to retrieve and modify the values of the plug-in's parameters. Note The parameter setters in this section may generate asynchronous requests.
AAX_Result | GetParameterValueFromString (AAX_CParamID iParameterID, double *oValue, const AAX_IString &iValueString) const AAX_OVERRIDE
| CALL: Converts a value string to a value.
AAX_Result | GetParameterStringFromValue (AAX_CParamID iParameterID, double iValue, AAX_IString *oValueString, int32_t iMaxLength) const AAX_OVERRIDE
| CALL: Converts a normalized parameter value into a string representing its corresponding real value.
AAX_Result | GetParameterValueString (AAX_CParamID iParameterID, AAX_IString *oValueString, int32_t iMaxLength) const AAX_OVERRIDE
| CALL: Retrieves the value string associated with a parameter's current value.
AAX_Result | GetParameterNormalizedValue (AAX_CParamID iParameterID, double *oValuePtr) const AAX_OVERRIDE
| CALL: Retrieves a parameter's current value.
AAX_Result | SetParameterNormalizedValue (AAX_CParamID iParameterID, double iValue) AAX_OVERRIDE
| CALL: Sets the specified parameter to a new value.
AAX_Result | SetParameterNormalizedRelative (AAX_CParamID iParameterID, double iValue) AAX_OVERRIDE
| CALL: Sets the specified parameter to a new value relative to its current value.
Automated parameter helpers
These methods are used to lock and unlock automation system 'resources' when updating automatable parameters. Note You should never need to override these methods to extend their behavior beyond what is provided in AAX_CEffectParameters and AAX_IParameter
AAX_Result | TouchParameter (AAX_CParamID iParameterID) AAX_OVERRIDE
| "Touches" (locks) a parameter in the automation system to a particular control in preparation for updates
AAX_Result | ReleaseParameter (AAX_CParamID iParameterID) AAX_OVERRIDE
| Releases a parameter from a "touched" state.
AAX_Result | UpdateParameterTouch (AAX_CParamID iParameterID, AAX_CBoolean iTouchState) AAX_OVERRIDE
| Sets a "touched" state on a parameter.
Asynchronous parameter update methods
These methods are called by the AAX host when parameter values have been updated. They are called by the host and can be triggered by other plug-in modules via calls to AAX_IParameter's `SetValue` methods, e.g. SetValueWithFloat() These methods are responsible for updating parameter values. Do not call these methods directly! To ensure proper synchronization and to avoid problematic dependency chains, other methods (e.g. SetParameterNormalizedValue()) and components (e.g. AAX_IEffectGUI) should always call a `SetValue` method on AAX_IParameter to update parameter values. The `SetValue` method will properly manage automation locks and other system resources.
AAX_Result | UpdateParameterNormalizedValue (AAX_CParamID iParameterID, double iValue, AAX_EUpdateSource iSource) AAX_OVERRIDE
| Updates a single parameter's state to its current value.
AAX_Result | UpdateParameterNormalizedRelative (AAX_CParamID iParameterID, double iValue) AAX_OVERRIDE
| Updates a single parameter's state to its current value, as a difference with the parameter's previous value.
AAX_Result | GenerateCoefficients (void) AAX_OVERRIDE
| Generates and dispatches new coefficient packets.
State reset handlers
AAX_Result | ResetFieldData (AAX_CFieldIndex inFieldIndex, void *oData, uint32_t inDataSize) const AAX_OVERRIDE
| Called by the host to reset a private data field in the plug-in's algorithm.
Chunk methods
These methods are used to save and restore collections of plug-in state information, known as chunks. Chunks are used by the host when saving or restoring presets and session settings and when providing "compare" functionality for plug-ins. The default implementation of these methods in AAX_CEffectParameters supports a single chunk that includes state information for all of the plug-in's registered parameters. Override all of these methods to add support for additional chunks in your plug-in, for example if your plug-ni contains any persistent state that is not encapsulated by its set of registered parameters. For reference, see also: AAX_CChunkDataParser AAX_SPlugInChunk
AAX_Result | GetNumberOfChunks (int32_t *oNumChunks) const AAX_OVERRIDE
| Retrieves the number of chunks used by this plug-in.
AAX_Result | GetChunkIDFromIndex (int32_t iIndex, AAX_CTypeID *oChunkID) const AAX_OVERRIDE
| Retrieves the ID associated with a chunk index.
AAX_Result | GetChunkSize (AAX_CTypeID iChunkID, uint32_t *oSize) const AAX_OVERRIDE
| Get the size of the data structure that can hold all of a chunk's information.
AAX_Result | GetChunk (AAX_CTypeID iChunkID, AAX_SPlugInChunk *oChunk) const AAX_OVERRIDE
| Fills a block of data with chunk information representing the plug-in's current state.
AAX_Result | SetChunk (AAX_CTypeID iChunkID, const AAX_SPlugInChunk *iChunk) AAX_OVERRIDE
| Restores a set of plug-in parameters based on chunk information.
AAX_Result | CompareActiveChunk (const AAX_SPlugInChunk *iChunkP, AAX_CBoolean *oIsEqual) const AAX_OVERRIDE
| Determine if a chunk represents settings that are equivalent to the plug-in's current state.
AAX_Result | GetNumberOfChanges (int32_t *oNumChanges) const AAX_OVERRIDE
| Retrieves the number of parameter changes made since the plug-in's creation.
Threads
Threading functions
AAX_Result | TimerWakeup () AAX_OVERRIDE
| Periodic wakeup callback for idle-time operations.
Auxiliary UI methods
Methods defining the presentation of the plug-in on auxiliary UIs such as control surfaces
AAX_Result | GetCurveData (AAX_CTypeID iCurveType, const float *iValues, uint32_t iNumValues, float *oValues) const AAX_OVERRIDE
| Generate a set of output values based on a set of given input values.
AAX_Result | GetCurveDataMeterIds (AAX_CTypeID iCurveType, uint32_t *oXMeterId, uint32_t *oYMeterId) const AAX_OVERRIDE
| Indicates which meters correspond to the X and Y axes of the EQ or Dynamics graph.
AAX_Result | GetCurveDataDisplayRange (AAX_CTypeID iCurveType, float *oXMin, float *oXMax, float *oYMin, float *oYMax) const AAX_OVERRIDE
| Determines the range of the graph shown by the plug-in.
AAX_Result | UpdatePageTable (uint32_t inTableType, int32_t inTablePageSize, IACFUnknown *iHostUnknown, IACFUnknown *ioPageTableUnknown) const AAX_OVERRIDE AAX_FINAL
| Allow the plug-in to update its page tables.
Custom Data Methods
These functions exist as a proxiable way to move data between different modules (e.g. AAX_IEffectParameters and AAX_IEffectGUI.) Using these, the GUI can query any data through GetCustomData() with a plug-in defined `typeID`, `void*` and size. This has an advantage over just sharing memory in that this function can work as a remote proxy as we enable those sorts of features later in the platform. Likewise, the GUI can also set arbitrary data on the data model by using the SetCustomData() function with the same idea. Note These are plug-in internal only. They are not called from the host right now, or likely ever.
AAX_Result | GetCustomData (AAX_CTypeID iDataBlockID, uint32_t inDataSize, void *oData, uint32_t *oDataWritten) const AAX_OVERRIDE
| An optional interface hook for getting custom data from another module.
AAX_Result | SetCustomData (AAX_CTypeID iDataBlockID, uint32_t inDataSize, const void *iData) AAX_OVERRIDE
| An optional interface hook for setting custom data for use by another module.
MIDI methods
AAX_Result | DoMIDITransfers () AAX_OVERRIDE
| MIDI update callback.
AAX_Result | UpdateMIDINodes (AAX_CFieldIndex inFieldIndex, AAX_CMidiPacket &iPacket) AAX_OVERRIDE
| MIDI update callback.
AAX_Result | UpdateControlMIDINodes (AAX_CTypeID nodeID, AAX_CMidiPacket &iPacket) AAX_OVERRIDE
| MIDI update callback for control MIDI nodes.
Hybrid audio methods
AAX_Result | RenderAudio_Hybrid (AAX_SHybridRenderInfo *ioRenderInfo) AAX_OVERRIDE
| Hybrid audio render function.
Private data accessors
AAX_IController * | Controller ()
| Access to the Effect controller.
const AAX_IController * | Controller () const
| `const` access to the Effect controller
AAX_ITransport * | Transport ()
| Access to the Transport object.
const AAX_ITransport * | Transport () const
| `const` access to the Transport object
AAX_IAutomationDelegate * | AutomationDelegate ()
| Access to the Effect's automation delegate.
const AAX_IAutomationDelegate * | AutomationDelegate () const
| `const` access to the Effect's automation delegate
Public Member Functions inherited from AAX_IEffectParameters
| ACF_DECLARE_STANDARD_UNKNOWN () ACFMETHOD(InternalQueryInterface)(const acfIID &riid
| AAX_DELETE (AAX_IEffectParameters &operator=(const AAX_IEffectParameters &))
Auxiliary UI methods
Auxiliary UI methods
Hybrid audio methods
MIDI methods
Initialization and uninitialization
AAX host and plug-in event notification
Parameter information
These methods are used by the AAX host to retrieve information about the plug-in's data model. For information about adding parameters to the plug-in and otherwise modifying the plug-in's data model, see AAX_CParameterManager. For information about parameters, see AAX_IParameter.
Parameter setters and getters
These methods are used by the AAX host and by the plug-in's UI to retrieve and modify the values of the plug-in's parameters. Note The parameter setters in this section may generate asynchronous requests.
Automated parameter helpers
These methods are used to lock and unlock automation system 'resources' when updating automatable parameters. Note You should never need to override these methods to extend their behavior beyond what is provided in AAX_CEffectParameters and AAX_IParameter
Asynchronous parameter update methods
These methods are called by the AAX host when parameter values have been updated. They are called by the host and can be triggered by other plug-in modules via calls to AAX_IParameter's `SetValue` methods, e.g. SetValueWithFloat() These methods are responsible for updating parameter values. Do not call these methods directly! To ensure proper synchronization and to avoid problematic dependency chains, other methods (e.g. SetParameterNormalizedValue()) and components (e.g. AAX_IEffectGUI) should always call a `SetValue` method on AAX_IParameter to update parameter values. The `SetValue` method will properly manage automation locks and other system resources.
State reset handlers
Chunk methods
These methods are used to save and restore collections of plug-in state information, known as chunks. Chunks are used by the host when saving or restoring presets and session settings and when providing "compare" functionality for plug-ins. The default implementation of these methods in AAX_CEffectParameters supports a single chunk that includes state information for all of the plug-in's registered parameters. Override all of these methods to add support for additional chunks in your plug-in, for example if your plug-in contains any persistent state that is not encapsulated by its set of registered parameters. Warning Remember that plug-in chunk data may be loaded on a different platform from the one where it is saved. All data structures in the chunk must be properly data-aligned for compatibility across all platforms that the plug-in supports. See AAX_ALIGN_FILE_ALG for notes about common cross-platform pitfalls for data structure alignment. For reference, see also: AAX_CChunkDataParser AAX_SPlugInChunk
Thread methods
Auxiliary UI methods
Custom data methods
These functions exist as a proxiable way to move data between different modules (e.g. AAX_IEffectParameters and AAX_IEffectGUI.) Using these, the GUI can query any data through GetCustomData() with a plug-in defined `typeID`, `void*` and size. This has an advantage over just sharing memory in that this function can work as a remote proxy as we enable those sorts of features later in the platform. Likewise, the GUI can also set arbitrary data on the data model by using the SetCustomData() function with the same idea. Note These are plug-in internal only. They are not called from the host right now, or likely ever.
MIDI methods
Public Member Functions inherited from IACFUnknown
virtual BEGIN_ACFINTERFACE ACFRESULT ACFMETHODCALLTYPE | QueryInterface (const acfIID &iid, void **ppOut)=0
| Returns pointers to supported interfaces.
virtual acfUInt32 ACFMETHODCALLTYPE | AddRef (void)=0
| Increments reference count.
virtual acfUInt32 ACFMETHODCALLTYPE | Release (void)=0
| Decrements reference count.

## Protected Member Functions
Parameter management methods
AAX_Result | SetTaperDelegate (AAX_CParamID iParameterID, AAX_ITaperDelegateBase &iTaperDelegate, bool iPreserveValue)
AAX_Result | SetDisplayDelegate (AAX_CParamID iParameterID, AAX_IDisplayDelegateBase &iDisplayDelegate)
bool | IsParameterTouched (AAX_CParamID iParameterID) const
bool | IsParameterLinkReady (AAX_CParamID inParameterID, AAX_EUpdateSource inSource) const

## Convenience functions
These convenience functions provide quick access to various aspects of the default AAX_CEffectParameters implementation.
int32_t | mNumPlugInChanges
int32_t | mChunkSize
AAX_CChunkDataParser | mChunkParser
int32_t | mNumChunkedParameters
AAX_CPacketDispatcher | mPacketDispatcher
AAX_CParameterManager | mParameterManager
std::set< std::string > | mFilteredParameters
virtual AAX_Result | EffectInit (void)
| Initialization helper routine. Called from AAX_CEffectParameters::Initialize.
virtual AAX_Result | UpdatePageTable (uint32_t, int32_t, AAX_IPageTable &) const
void | FilterParameterIDOnSave (AAX_CParamID controlID)
| CALL: Indicates the indices of parameters that should not be saved in the default AAX_CEffectParameters chunk.
void | BuildChunkData (void) const
| Clears out the current chunk in Chunk Parser and adds all of the new values. Used by default implementations of GetChunk() and GetChunkSize().

## Additional Inherited Members
Public Attributes inherited from AAX_IEffectParameters
void **ppvObjOut | override

## Constructor & Destructor Documentation

## ◆ AAX_CEffectParameters()

AAX_CEffectParameters::AAX_CEffectParameters | ( | void |  | ) |

## ◆ ~AAX_CEffectParameters()

AAX_CEffectParameters::~AAX_CEffectParameters | ( | void |  | ) |

## Member Function Documentation

## ◆ operator=()

AAX_CEffectParameters & AAX_CEffectParameters::operator= | ( | const AAX_CEffectParameters & | other | ) |

## ◆ Initialize()

AAX_Result AAX_CEffectParameters::Initialize | ( | IACFUnknown * | iController | ) |
| virtual

Main data model initialization. Called when plug-in instance is first instantiated.

Note
  Most plug-ins should override AAX_CEffectParameters::EffectInit() rather than directly overriding this method

Parameters

  [in] | iController | A versioned reference that resolves to an AAX_IController interface

This default implementation calls EffectInit(). Only override Initialize() when additional initialization steps must be performed prior to EffectInit().

Implements AAX_IACFEffectParameters.

## ◆ Uninitialize()

AAX_Result AAX_CEffectParameters::Uninitialize | ( | void |  | ) |
| virtual

Main data model uninitialization.

Todo:
  Docs: When exactly is AAX_IACFEffectParameters::Uninitialize() called, and under what conditions?

Implements AAX_IACFEffectParameters.

## ◆ NotificationReceived()

AAX_Result AAX_CEffectParameters::NotificationReceived | ( | AAX_CTypeID | inNotificationType,
|  | const void * | inNotificationData,
|  | uint32_t | inNotificationDataSize
| ) |  |
| virtual

Notification Hook.

Called from the host to deliver notifications to this object.

Look at the AAX_ENotificationEvent enumeration to see a description of events you can listen for and the data they come with.

- Note
    some notifications are sent only to the plug-in GUI while other notifications are sent only to the plug-in data model. If you are not seeing an expected notification, try checking the other plug-in objects' `NotificationReceived()` methods.
- Note
    the host may dispatch notifications synchronously or asynchronously, and calls to this method may occur concurrently on multiple threads.
  A plug-in may also dispatch custom notifications using AAX_IController::SendNotification(). Custom notifications will be posted back to the plug-in's other objects which support a `NotificationReceived()` method (e.g. the GUI).

Parameters

  [in] | inNotificationType | Type of notification being received. Notifications form the host are one of AAX_ENotificationEvent
  [in] | inNotificationData | Block of incoming notification data
  [in] | inNotificationDataSize | Size of `inNotificationData`, in bytes

Implements AAX_IACFEffectParameters.

## ◆ GetNumberOfParameters()

AAX_Result AAX_CEffectParameters::GetNumberOfParameters | ( | int32_t * | oNumControls | ) | const
| virtual

CALL: Retrieves the total number of plug-in parameters.

Parameters

  [out] | oNumControls | The number of parameters in the plug-in's Parameter Manager

Implements AAX_IACFEffectParameters.

## ◆ GetMasterBypassParameter()

AAX_Result AAX_CEffectParameters::GetMasterBypassParameter | ( | AAX_IString * | oIDString | ) | const
| virtual

CALL: Retrieves the ID of the plug-in's Master Bypass parameter.

This is required if you want our master bypass functionality in the host to hook up to your bypass parameters.

Parameters

  [out] | oIDString | The ID of the plug-in's Master Bypass control

Implements AAX_IACFEffectParameters.

## ◆ GetParameterIsAutomatable()

AAX_Result AAX_CEffectParameters::GetParameterIsAutomatable | ( | AAX_CParamID | iParameterID,
|  | AAX_CBoolean * | oAutomatable
| ) |  | const
| virtual

CALL: Retrieves information about a parameter's automatable status.

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oAutomatable | True if the queried parameter is automatable, false if it is not

Implements AAX_IACFEffectParameters.

## ◆ GetParameterNumberOfSteps()

AAX_Result AAX_CEffectParameters::GetParameterNumberOfSteps | ( | AAX_CParamID | iParameterID,
|  | int32_t * | oNumSteps
| ) |  | const
| virtual

CALL: Retrieves the number of discrete steps for a parameter.

Note
  The value returned for `oNumSteps` MUST be greater than zero. All other values will be considered an error by the host.

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oNumSteps | The number of steps for this parameter

Implements AAX_IACFEffectParameters.

## ◆ GetParameterName()

AAX_Result AAX_CEffectParameters::GetParameterName | ( | AAX_CParamID | iParameterID,
|  | AAX_IString * | oName
| ) |  | const
| virtual

CALL: Retrieves the full name for a parameter.

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oName | Reference to an AAX_IString owned by the host. The plug-in must set this string equal to the parameter's full name.

Implements AAX_IACFEffectParameters.

## ◆ GetParameterNameOfLength()

AAX_Result AAX_CEffectParameters::GetParameterNameOfLength | ( | AAX_CParamID | iParameterID,
|  | AAX_IString * | oName,
|  | int32_t | iNameLength
| ) |  | const
| virtual

CALL: Retrieves an abbreviated name for a parameter.

In general, lengths of 3 through 8 and 31 should be specifically addressed.

Host Compatibility Notes:
  In most cases, the AAX host will call GetParameterName() or GetParameterNameOfLength() to retrieve parameter names for display. However, when Pro Tools is retrieving a plug-in name for display on a control surface the XML data stored in the plug-in's page tables will be used in preference to values retrieved from these methods.

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oName | Reference to an AAX_IString owned by the host. The plug-in must set this string equal to an abbreviated name for the parameter, using `iNameLength` characters or fewer.
  [in] | iNameLength | The maximum number of characters in `oName`

Implements AAX_IACFEffectParameters.

## ◆ GetParameterDefaultNormalizedValue()

AAX_Result AAX_CEffectParameters::GetParameterDefaultNormalizedValue | ( | AAX_CParamID | iParameterID,
|  | double * | oValue
| ) |  | const
| virtual

CALL: Retrieves default value of a parameter.

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oValue | The parameter's default value

Implements AAX_IACFEffectParameters.

## ◆ SetParameterDefaultNormalizedValue()

AAX_Result AAX_CEffectParameters::SetParameterDefaultNormalizedValue | ( | AAX_CParamID | iParameterID,
|  | double | iValue
| ) |  |
| virtual

CALL: Sets the default value of a parameter.

Parameters

  [in] | iParameterID | The ID of the parameter that is being updated
  [out] | iValue | The parameter's new default value

Todo:
  THIS IS NOT CALLED FROM HOST. USEFUL FOR INTERNAL USE ONLY?

Implements AAX_IACFEffectParameters.

## ◆ GetParameterType()

AAX_Result AAX_CEffectParameters::GetParameterType | ( | AAX_CParamID | iParameterID,
|  | AAX_EParameterType * | oParameterType
| ) |  | const
| virtual

CALL: Retrieves the type of a parameter.

Todo:
  The concept of parameter type needs more documentation

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oParameterType | The parameter's type

Implements AAX_IACFEffectParameters.

## ◆ GetParameterOrientation()

AAX_Result AAX_CEffectParameters::GetParameterOrientation | ( | AAX_CParamID | iParameterID,
|  | AAX_EParameterOrientation * | oParameterOrientation
| ) |  | const
| virtual

CALL: Retrieves the orientation that should be applied to a parameter's controls.

Todo:
  update this documentation

This method allows you to specify the orientation of knob controls that are managed by the host (e.g. knobs on an attached control surface.)

Here is an example override of this method that reverses the orientation of a control for a parameter:

// AAX_IParameter* myBackwardsParameter
if (iParameterID == myBackwardsParameter->Identifier())
{
*oParameterType =
AAX_eParameterOrientation_BottomMinTopMax |
AAX_eParameterOrientation_LeftMinRightMax |
AAX_eParameterOrientation_RotaryWrapMode |
AAX_eParameterOrientation_RotaryLeftMinRightMax;
}
AAX_eParameterOrientation_BottomMinTopMax
@ AAX_eParameterOrientation_BottomMinTopMax
Definition: AAX_Enums.h:866
AAX_eParameterOrientation_LeftMinRightMax
@ AAX_eParameterOrientation_LeftMinRightMax
Definition: AAX_Enums.h:869
AAX_eParameterOrientation_RotaryLeftMinRightMax
@ AAX_eParameterOrientation_RotaryLeftMinRightMax
Definition: AAX_Enums.h:879
AAX_eParameterOrientation_RotaryWrapMode
@ AAX_eParameterOrientation_RotaryWrapMode
Definition: AAX_Enums.h:875

The orientation options are set according to AAX_EParameterOrientationBits

Legacy Porting Notes:
  AAX_IEffectParameters::GetParameterOrientation() corresponds to the GetControlOrientation() method in the legacy RTAS/TDM SDK.

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oParameterOrientation | The orientation of the parameter

Implements AAX_IACFEffectParameters.

## ◆ GetParameter()

AAX_Result AAX_CEffectParameters::GetParameter | ( | AAX_CParamID | iParameterID,
|  | AAX_IParameter ** | oParameter
| ) |  |
| virtual

CALL: Retrieves an arbitrary setting within a parameter.

This is a convenience function for accessing the richer parameter interface from the plug-in's other modules.

Note
  This function must not be called by the host; AAX_IParameter is not safe for passing across the binary boundary with the host!

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oParameter | A pointer to the returned parameter

Implements AAX_IACFEffectParameters.

## ◆ GetParameterIndex()

AAX_Result AAX_CEffectParameters::GetParameterIndex | ( | AAX_CParamID | iParameterID,
|  | int32_t * | oControlIndex
| ) |  | const
| virtual

CALL: Retrieves the index of a parameter.

Although parameters are normally referenced by their AAX_CParamID, each parameter is also associated with a unique numeric index.

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oControlIndex | The parameter's numeric index

Implements AAX_IACFEffectParameters.

## ◆ GetParameterIDFromIndex()

AAX_Result AAX_CEffectParameters::GetParameterIDFromIndex | ( | int32_t | iControlIndex,
|  | AAX_IString * | oParameterIDString
| ) |  | const
| virtual

CALL: Retrieves the ID of a parameter.

This method can be used to convert a parameter's unique numeric index to its AAX_CParamID

Parameters

  [in] | iControlIndex | The numeric index of the parameter that is being queried
  [out] | oParameterIDString | Reference to an AAX_IString owned by the host. The plug-in must set this string equal to the parameter's ID.

Implements AAX_IACFEffectParameters.

## ◆ GetParameterValueInfo()

AAX_Result AAX_CEffectParameters::GetParameterValueInfo | ( | AAX_CParamID | iParameterID,
|  | int32_t | iSelector,
|  | int32_t * | oValue
| ) |  | const
| virtual

CALL: Retrieves a property of a parameter.

This is a general purpose query that is specialized based on the value of `iSelector`. The currently supported selector values are described by AAX_EParameterValueInfoSelector . The meaning of `oValue` is dependent upon `iSelector` .

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [in] | iSelector | The selector of the parameter value to retrieve. See AAX_EParameterValueInfoSelector
  [out] | oValue | The value of the specified parameter

Implements AAX_IACFEffectParameters.

## ◆ GetParameterValueFromString()

AAX_Result AAX_CEffectParameters::GetParameterValueFromString | ( | AAX_CParamID | iParameterID,
|  | double * | oValue,
|  | const AAX_IString & | iValueString
| ) |  | const
| virtual

CALL: Converts a value string to a value.

This method uses the queried parameter's display delegate and taper to convert a `char*` string into its corresponding value. The formatting of valueString must be supported by the parameter's display delegate in order for this call to succeed.

Legacy Porting Notes:
  This method corresponds to CProcess::MapControlStringToVal() in the RTAS/TDM SDK

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oValue | The value associated with valueString
  [in] | iValueString | The formatted value string that will be converted into a value

Implements AAX_IACFEffectParameters.

## ◆ GetParameterStringFromValue()

AAX_Result AAX_CEffectParameters::GetParameterStringFromValue | ( | AAX_CParamID | iParameterID,
|  | double | iValue,
|  | AAX_IString * | oValueString,
|  | int32_t | iMaxLength
| ) |  | const
| virtual

CALL: Converts a normalized parameter value into a string representing its corresponding real value.

This method uses the queried parameter's display delegate and taper to convert a normalized value into the corresponding `char*` value string for its real value.

Legacy Porting Notes:
  This method corresponds to CProcess::MapControlValToString() in the RTAS/TDM SDK

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [in] | iValue | The normalized value that will be converted to a formatted valueString
  [out] | oValueString | The formatted value string associated with value
  [in] | iMaxLength | The maximum length of valueString

Implements AAX_IACFEffectParameters.

## ◆ GetParameterValueString()

AAX_Result AAX_CEffectParameters::GetParameterValueString | ( | AAX_CParamID | iParameterID,
|  | AAX_IString * | oValueString,
|  | int32_t | iMaxLength
| ) |  | const
| virtual

CALL: Retrieves the value string associated with a parameter's current value.

This method uses the queried parameter's display delegate and taper to convert its current value into a corresponding `char*` value string.

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oValueString | The formatted value string associated with the parameter's current value
  [in] | iMaxLength | The maximum length of valueString

Implements AAX_IACFEffectParameters.

## ◆ GetParameterNormalizedValue()

AAX_Result AAX_CEffectParameters::GetParameterNormalizedValue | ( | AAX_CParamID | iParameterID,
|  | double * | oValuePtr
| ) |  | const
| virtual

CALL: Retrieves a parameter's current value.

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [out] | oValuePtr | The parameter's current value

Implements AAX_IACFEffectParameters.

## ◆ SetParameterNormalizedValue()

AAX_Result AAX_CEffectParameters::SetParameterNormalizedValue | ( | AAX_CParamID | iParameterID,
|  | double | iValue
| ) |  |
| virtual

CALL: Sets the specified parameter to a new value.

SetParameterNormalizedValue() is responsible for initiating any process that is required in order to update all of the parameter's controls (e.g. in the plug-in's GUI, on control surfaces, in automation lanes, etc.) In most cases, the parameter manager will handle this initiation step.

Parameters

  [in] | iParameterID | The ID of the parameter that is being set
  [in] | iValue | The value to which the parameter should be set

Implements AAX_IACFEffectParameters.

## ◆ SetParameterNormalizedRelative()

AAX_Result AAX_CEffectParameters::SetParameterNormalizedRelative | ( | AAX_CParamID | iParameterID,
|  | double | iValue
| ) |  |
| virtual

CALL: Sets the specified parameter to a new value relative to its current value.

This method is used in cases when a relative control value is more convenient, for example when updating a GUI control using a mouse wheel or the arrow keys. Note that the host may apply the parameter's step size prior to calling SetParameterNormalizedRelative() in order to determine the correct value for aValue.

SetParameterNormalizedRelative() can be used to incorporate "wrapping" behavior in a parameter's controls, if desired. If this behavior is not desired, then this method must properly account for overflow of the parameter's normalized value.

SetParameterNormalizedRelative() is responsible for initiating any process that is required in order to update all of the parameter's controls (e.g. in the plug-in's GUI, on control surfaces, in automation lanes, etc.) In most cases, the parameter manager will handle this initiation step.

See also UpdateParameterNormalizedRelative().

Todo:
  REMOVE THIS METHOD (?)

Parameters

  [in] | iParameterID | The ID of the parameter that is being queried
  [in] | iValue | The change in value that should be applied to the parameter

Todo:
  NOT CURRENTLY CALLED FROM THE HOST. USEFUL FOR INTERNAL USE ONLY?

Implements AAX_IACFEffectParameters.

## ◆ TouchParameter()

AAX_Result AAX_CEffectParameters::TouchParameter | ( | AAX_CParamID | iParameterID | ) |
| virtual

"Touches" (locks) a parameter in the automation system to a particular control in preparation for updates

This method is called by the Parameter Manager to prime a parameter for receiving new automation data. When an automatable parameter is touched by a control, it will reject input from other controls until it is released.

Note
  You should never need to override this method when using AAX_CEffectParameters.

Parameters

  [in] | iParameterID | The parameter that is being touched

Implements AAX_IACFEffectParameters.

## ◆ ReleaseParameter()

AAX_Result AAX_CEffectParameters::ReleaseParameter | ( | AAX_CParamID | iParameterID | ) |
| virtual

Releases a parameter from a "touched" state.

This method is called by the Parameter Manager to release a parameter so that any control may send updates to the parameter.

Note
  You should never need to override this method when using AAX_CEffectParameters.

Parameters

  [in] | iParameterID | The parameter that is being released

Implements AAX_IACFEffectParameters.

## ◆ UpdateParameterTouch()

AAX_Result AAX_CEffectParameters::UpdateParameterTouch | ( | AAX_CParamID | iParameterID,
|  | AAX_CBoolean | iTouchState
| ) |  |
| virtual

Sets a "touched" state on a parameter.

Note
  This method should be overriden when dealing with linked parameters. Do NOT use this method to keep track of touch states. Use the automation delegate for that.

Parameters

  [in] | iParameterID | The parameter that is changing touch states.
  [in] | iTouchState | The touch state of the parameter.

Implements AAX_IACFEffectParameters.

## ◆ UpdateParameterNormalizedValue()

AAX_Result AAX_CEffectParameters::UpdateParameterNormalizedValue | ( | AAX_CParamID | iParameterID,
|  | double | iValue,
|  | AAX_EUpdateSource | iSource
| ) |  |
| virtual

Updates a single parameter's state to its current value.

Note
  Do not call this method from the plug-in. This method should be called by the host only. To set parameter values from within the plug-in, use the AAX_IParameter interface.

Todo:
  FLAGGED FOR CONSIDERATION OF REVISION

Parameters

  [in] | iParameterID | The ID of the parameter that is being updated
  [in] | iValue | The parameter's current value, to which its internal state must be updated
  [in] | iSource | The source of the update

Implements AAX_IACFEffectParameters.

Reimplemented in AAX_CMonolithicParameters.

Referenced by AAX_CMonolithicParameters::UpdateParameterNormalizedValue().

Here is the caller graph for this function:

## ◆ UpdateParameterNormalizedRelative()

AAX_Result AAX_CEffectParameters::UpdateParameterNormalizedRelative | ( | AAX_CParamID | iParameterID,
|  | double | iValue
| ) |  |
| virtual

Updates a single parameter's state to its current value, as a difference with the parameter's previous value.

Deprecated:
  This is not called from the host. It may still be useful for internal calls within the plug-in, though it should only ever be used to update non-automatable parameters. Automatable parameters should always be updated through the AAX_IParameter interface, which will ensure proper coordination with other automation clients.

UpdateParameterNormalizedRelative() can be used to incorporate "wraparound" behavior in a parameter's controls, if desired. If this behavior is not desired, then this method must properly account for overflow of the parameter's normalized value.

See also
  SetParameterNormalizedRelative()

Parameters

  [in] | iParameterID | The ID of the parameter that is being updated
  [in] | iValue | The difference between the parameter's current value and its previous value (normalized). The parameter's state must be updated to reflect this difference.

Implements AAX_IACFEffectParameters.

## ◆ GenerateCoefficients()

AAX_Result AAX_CEffectParameters::GenerateCoefficients | ( | void |  | ) |
| virtual

Generates and dispatches new coefficient packets.

This method is responsible for updating the coefficient packets associated with all parameters whose states have changed since the last call to GenerateCoefficients(). The host may call this method once for every parameter update, or it may "batch" parameter updates such that changes for several parameters are all handled by a single call to GenerateCoefficients().

For more information on tracking parameters' statuses using the AAX_CPacketDispatcher, helper class, see AAX_CPacketDispatcher::SetDirty().

Note
  Do not call this method from the plug-in. This method should be called by the host only. To set parameter values from within the plug-in, use the AAX_IParameter interface.

Implements AAX_IACFEffectParameters.

Reimplemented in AAX_CMonolithicParameters.

Referenced by AAX_CMonolithicParameters::GenerateCoefficients().

Here is the caller graph for this function:

## ◆ ResetFieldData()

AAX_Result AAX_CEffectParameters::ResetFieldData | ( | AAX_CFieldIndex | inFieldIndex,
|  | void * | oData,
|  | uint32_t | inDataSize
| ) |  | const
| virtual

Called by the host to reset a private data field in the plug-in's algorithm.

This method is called sequentially for all private data fields on Effect initialization and during any "reset" event, such as priming for a non-real-time render. This method is called before the algorithm's optional initialization callback, and the initialized private data will be available within that callback via its context block.

See also
  Algorithm initialization.

Warning
  Any data structures that will be passed between platforms (for example, sent to a TI DSP in an AAX DSP plug-in) must be properly data-aligned for compatibility across both platforms. See AAX_ALIGN_FILE_ALG for more information about guaranteeing cross-platform compatibility of data structures used for algorithm processing.

Parameters

  [in] | inFieldIndex | The index of the field that is being initialized
  [out] | oData | The pre-allocated block of data that should be initialized
  [in] | inDataSize | The size of the data block, in bytes

Implements AAX_IACFEffectParameters.

Reimplemented in AAX_CMonolithicParameters.

Referenced by AAX_CMonolithicParameters::ResetFieldData().

Here is the caller graph for this function:

## ◆ GetNumberOfChunks()

AAX_Result AAX_CEffectParameters::GetNumberOfChunks | ( | int32_t * | oNumChunks | ) | const
| virtual

Retrieves the number of chunks used by this plug-in.

Parameters

  [out] | oNumChunks | The number of distinct chunks used by this plug-in

Implements AAX_IACFEffectParameters.

## ◆ GetChunkIDFromIndex()

AAX_Result AAX_CEffectParameters::GetChunkIDFromIndex | ( | int32_t | iIndex,
|  | AAX_CTypeID * | oChunkID
| ) |  | const
| virtual

Retrieves the ID associated with a chunk index.

Parameters

  [in] | iIndex | Index of the queried chunk
  [out] | oChunkID | ID of the queried chunk

Implements AAX_IACFEffectParameters.

## ◆ GetChunkSize()

AAX_Result AAX_CEffectParameters::GetChunkSize | ( | AAX_CTypeID | iChunkID,
|  | uint32_t * | oSize
| ) |  | const
| virtual

Get the size of the data structure that can hold all of a chunk's information.

If chunkID is one of the plug-in's custom chunks, initialize *size to the size of the chunk's data in bytes.

This method is invoked every time a chunk is saved, therefore it is possible to have dynamically sized chunks. However, note that each call to GetChunkSize() will correspond to a following call to GetChunk(). The chunk provided in GetChunk() must have the same size as the size provided by GetChunkSize().

Legacy Porting Notes:
  In AAX, the value provided by GetChunkSize() should NOT include the size of the chunk header. The value should ONLY reflect the size of the chunk's data.

Parameters

  [in] | iChunkID | ID of the queried chunk
  [out] | oSize | The chunk's size in bytes

Implements AAX_IACFEffectParameters.

## ◆ GetChunk()

AAX_Result AAX_CEffectParameters::GetChunk | ( | AAX_CTypeID | iChunkID,
|  | AAX_SPlugInChunk * | oChunk
| ) |  | const
| virtual

Fills a block of data with chunk information representing the plug-in's current state.

By calling this method, the host is requesting information about the current state of the plug-in. The following chunk fields should be explicitly populated in this method. Other fields will be populated by the host.

- AAX_SPlugInChunk::fData
- AAX_SPlugInChunk::fVersion
- AAX_SPlugInChunk::fName (Optional)
- AAX_SPlugInChunk::fSize (Data size only)

Warning
  Remember that this chunk data may be loaded on a different platform from the one where it is saved. All data structures in the chunk must be properly data-aligned for compatibility across all platforms that the plug-in supports. See AAX_ALIGN_FILE_ALG for notes about common cross-platform pitfalls for data structure alignment.

Parameters

  [in] | iChunkID | ID of the chunk that should be provided
  [out] | oChunk | A preallocated block of memory that should be populated with the chunk's data.

Implements AAX_IACFEffectParameters.

## ◆ SetChunk()

AAX_Result AAX_CEffectParameters::SetChunk | ( | AAX_CTypeID | iChunkID,
|  | const AAX_SPlugInChunk * | iChunk
| ) |  |
| virtual

Restores a set of plug-in parameters based on chunk information.

By calling this method, the host is attempting to update the plug-in's current state to match the data stored in a chunk. The plug-in should initialize itself to this new state by calling SetParameterNormalizedValue() for each of the relevant parameters.

Parameters

  [in] | iChunkID | ID of the chunk that is being set
  [in] | iChunk | The chunk

Implements AAX_IACFEffectParameters.

## ◆ CompareActiveChunk()

AAX_Result AAX_CEffectParameters::CompareActiveChunk | ( | const AAX_SPlugInChunk * | iChunkP,
|  | AAX_CBoolean * | oIsEqual
| ) |  | const
| virtual

Determine if a chunk represents settings that are equivalent to the plug-in's current state.

Host Compatibility Notes:
  In Pro Tools, this method will only be called if a prior call to GetNumberOfChanges() has indicated that the plug-in's state has changed. If the plug-in's current settings are different from the settings in `aChunkP` then the plug-in's Compare Light will be illuminated in the plug-in header, allowing users to toggle between the plug-in's custom state and its saved state.

Parameters

  [in] | iChunkP | The chunk that is to be tested
  [out] | oIsEqual | True if the chunk represents equivalent settings when compared with the plug-in's current state. False if the chunk represents non-equivalent settings

Implements AAX_IACFEffectParameters.

## ◆ GetNumberOfChanges()

AAX_Result AAX_CEffectParameters::GetNumberOfChanges | ( | int32_t * | oNumChanges | ) | const
| virtual

Retrieves the number of parameter changes made since the plug-in's creation.

This method is polled regularly by the host, and can additionally be triggered by some events such as mouse clicks. When the number provided by this method changes, the host subsequently calls CompareActiveChunk() to determine if the plug-in's Compare light should be activated.

The value provided by this method should increment with each call to UpdateParameterNormalizedValue()

Parameters

  [out] | oNumChanges | Must be set to indicate the number of parameter changes that have occurred since plug-in initialization.

Implements AAX_IACFEffectParameters.

## ◆ TimerWakeup()

AAX_Result AAX_CEffectParameters::TimerWakeup | ( |  | ) |
| virtual

Periodic wakeup callback for idle-time operations.

This method is called from the host using a non-main thread. In general, it should be driven at approximately one call per 30 ms. However, the wakeup is not guaranteed to be called at any regular interval - for example, it could be held off by a high real-time processing load - and there is no host contract regarding maximum latency between wakeup calls.

This wakeup thread runs continuously and cannot be armed/disarmed or by the plug-in.

Implements AAX_IACFEffectParameters.

Reimplemented in AAX_CMonolithicParameters.

Referenced by AAX_CMonolithicParameters::TimerWakeup().

Here is the caller graph for this function:

## ◆ GetCurveData()

AAX_Result AAX_CEffectParameters::GetCurveData | ( | AAX_CTypeID | iCurveType,
|  | const float * | iValues,
|  | uint32_t | iNumValues,
|  | float * | oValues
| ) |  | const
| virtual

Generate a set of output values based on a set of given input values.

This method is used by the host to generate graphical curves. Given a set of input values, e.g. frequencies in Hz, this method should generate a corresponding set of output values, e.g. dB gain at each frequency. The semantics of these input and output values are dictated by `iCurveType`. See AAX_ECurveType.

Plug-ins may also define custom curve type IDs to use this method internally. For example, the plug-in's GUI could use this method to request curve data in an arbitrary format.

- Note
    This method may be called by the host simultaneously from multiple threads with differents `iValues`.
- Note
    `oValues` must be allocated by caller with the same size as `iValues` (`iNumValues`).
  Host Compatibility Notes:
    Versions of S6 software which support the GetCurveDataDisplayRange() method will not display a plug-in's curve data unless both GetCurveData() and GetCurveDataDisplayRange() are supported by the plug-in.

Warning
  S6 currently polls this method to update a plug-in's EQ or dynamics curves based on changes to the parameters mapped to the plug-in's EQ or dynamics center section page tables. Parameters that are not included in these page tables will not trigger updates to the curves displayed on S6. (GWSW-7314, PTSW-195316 / PT-218485)

Parameters

  [in] | iCurveType | One of AAX_ECurveType
  [in] | iValues | An array of input values
  [in] | iNumValues | The size of `iValues`
  [out] | oValues | An array of ouptut values

Returns
  This method must return AAX_ERROR_UNIMPLEMENTED if the plug-in does not support curve data for the requested `iCurveType`

Implements AAX_IACFEffectParameters.

## ◆ GetCurveDataMeterIds()

AAX_Result AAX_CEffectParameters::GetCurveDataMeterIds | ( | AAX_CTypeID | iCurveType,
|  | uint32_t * | oXMeterId,
|  | uint32_t * | oYMeterId
| ) |  | const
| virtual

Indicates which meters correspond to the X and Y axes of the EQ or Dynamics graph.

These meters can be used by attached control surfaces to present an indicator in the same X/Y coordinate plane as the plug-in's curve data.

Parameters

  [in] | iCurveType | One of AAX_ECurveType
  [out] | oXMeterId | Id of the X-axis meter
  [out] | oYMeterId | Id of the Y-axis meter

Returns
  This method should return AAX_ERROR_UNIMPLEMENTED if the plug-in does not implement it.

Implements AAX_IACFEffectParameters_V3.

## ◆ GetCurveDataDisplayRange()

AAX_Result AAX_CEffectParameters::GetCurveDataDisplayRange | ( | AAX_CTypeID | iCurveType,
|  | float * | oXMin,
|  | float * | oXMax,
|  | float * | oYMin,
|  | float * | oYMax
| ) |  | const
| virtual

Determines the range of the graph shown by the plug-in.

Min/max arguments define the range of the axes of the graph.

Parameters

  [in] | iCurveType | One of AAX_ECurveType
  [out] | oXMin | Min value of X-axis range
  [out] | oXMax | Max value of X-axis range
  [out] | oYMin | Min value of Y-axis range
  [out] | oYMax | Max value of Y-axis range

Returns
  This method should return AAX_ERROR_UNIMPLEMENTED if the plug-in does not implement it.

Implements AAX_IACFEffectParameters_V3.

## ◆ UpdatePageTable() [1/2]

AAX_Result AAX_CEffectParameters::UpdatePageTable | ( | uint32_t | inTableType,
|  | int32_t | inTablePageSize,
|  | IACFUnknown * | iHostUnknown,
|  | IACFUnknown * | ioPageTableUnknown
| ) |  | const
| virtual

Allow the plug-in to update its page tables.

Called by the plug-in host, usually in response to a AAX_eNotificationEvent_ParameterMappingChanged notification sent from the plug-in.

Use this method to change the page table mapping for the plug-in instance or to apply other changes to auxiliary UIs which use the plug-in page tables, such as setting focus to a new page.

See Page Table Guide for more information about page tables.

Parameters

  [in] | inTableType | Four-char type identifier for the table type (e.g. `'PgTL'`, `'Av81'`, etc.)
  [in] | inTablePageSize | Page size for the table
  [in] | iHostUnknown | Unknown interface from the host which may support interfaces providing additional features or information. All interfaces queried from this unknown will be valid only within the scope of this UpdatePageTable() execution and will be relevant for only the current plug-in instance.
  [in,out] | ioPageTableUnknown | Unknown interface which supports AAX_IPageTable. This object represents the page table data which is currently stored by the host for this plug-in instance for the given table type and page size. This data and may be edited within the scope of UpdatePageTable() to change the page table mapping for this plug-in instance.

Returns
  This method should return AAX_ERROR_UNIMPLEMENTED if the plug-in does not implement it or when no change is requested by the plug-in. This allows optimizations to be used in the host when no UI update is required following this call.

See also
  AAX_eNotificationEvent_ParameterMappingChanged

Note
  For convenience, do not override this method. Instead, override the protected overload which provides a prepared copy of the relevant AAX_IPageTable host interface.

Implements AAX_IACFEffectParameters_V4.

## ◆ GetCustomData()

AAX_Result AAX_CEffectParameters::GetCustomData | ( | AAX_CTypeID | iDataBlockID,
|  | uint32_t | inDataSize,
|  | void * | oData,
|  | uint32_t * | oDataWritten
| ) |  | const
| virtual

An optional interface hook for getting custom data from another module.

Parameters

  [in] | iDataBlockID | Identifier for the requested block of custom data
  [in] | inDataSize | Size of provided buffer, in bytes
  [out] | oData | Pointer to an allocated buffer. Data will be written here.
  [out] | oDataWritten | The number of bytes actually written

Implements AAX_IACFEffectParameters.

## ◆ SetCustomData()

AAX_Result AAX_CEffectParameters::SetCustomData | ( | AAX_CTypeID | iDataBlockID,
|  | uint32_t | inDataSize,
|  | const void * | iData
| ) |  |
| virtual

An optional interface hook for setting custom data for use by another module.

Parameters

  [in] | iDataBlockID | Identifier for the provided block of custom data
  [in] | inDataSize | Size of provided buffer, in bytes
  [in] | iData | Pointer to the data buffer

Implements AAX_IACFEffectParameters.

## ◆ DoMIDITransfers()

AAX_Result AAX_CEffectParameters::DoMIDITransfers | ( |  | ) |
| inline virtual

MIDI update callback.

Call AAX_IController::GetNextMIDIPacket() from within this method to retrieve and process MIDI packets directly within the Effect's data model. MIDI data will also be delivered to the Effect algorithm.

This method is called regularly by the host, similarly to AAX_IEffectParameters::TimerWakeup()

Implements AAX_IACFEffectParameters.

References AAX_SUCCESS.

## ◆ UpdateMIDINodes()

AAX_Result AAX_CEffectParameters::UpdateMIDINodes | ( | AAX_CFieldIndex | inFieldIndex,
|  | AAX_CMidiPacket & | iPacket
| ) |  |
| virtual

MIDI update callback.

This method is called by the host for each pending MIDI packet for MIDI nodes in algorithm context structure. Overwrite this method in Plug-In's EffectParameter class if you want to receive MIDI data packets directly in the data model. MIDI data will also be delivered to the Effect algorithm.

The host calls this method in Effects that register one or more MIDI nodes using AAX_IComponentDescriptor::AddMIDINode(). Effects that do not require MIDI data to be sent to the plug-in algorithm should override UpdateControlMIDINodes().

Parameters

  [in] | inFieldIndex | MIDI node field index in algorithm context structure
  [in] | iPacket | The incoming MIDI packet for the node

Implements AAX_IACFEffectParameters_V2.

## ◆ UpdateControlMIDINodes()

AAX_Result AAX_CEffectParameters::UpdateControlMIDINodes | ( | AAX_CTypeID | nodeID,
|  | AAX_CMidiPacket & | iPacket
| ) |  |
| virtual

MIDI update callback for control MIDI nodes.

This method is called by the host for each pending MIDI packet for Control MIDI nodes. Overwrite this method in Plug-In's EffectParameter class if you want to receive MIDI data packets directly in the data model.

The host calls this method in Effects that register one or more Control MIDI nodes using AAX_IEffectDescriptor::AddControlMIDINode(). Effects with algorithms that use MIDI data nodes should override UpdateMIDINodes().

Note
  This method will not be called if an Effect includes any MIDI nodes in its algorithm context structure.

Parameters

  [in] | nodeID | Identifier for the MIDI node
  [in] | iPacket | The incoming MIDI packet for the node

Implements AAX_IACFEffectParameters_V2.

## ◆ RenderAudio_Hybrid()

AAX_Result AAX_CEffectParameters::RenderAudio_Hybrid | ( | AAX_SHybridRenderInfo * | ioRenderInfo | ) |
| virtual

Hybrid audio render function.

This method is called from the host to render audio for the hybrid piece of the algorithm.

Note
  To use this method plug-in should register some hybrid inputs and ouputs in "Describe"

Implements AAX_IACFEffectParameters_V2.

## ◆ Controller() [1/2]

AAX_IController * AAX_CEffectParameters::Controller | ( |  | ) |

Access to the Effect controller.

Referenced by AAX_CMonolithicParameters::GenerateCoefficients().

Here is the caller graph for this function:

## ◆ Controller() [2/2]

const AAX_IController * AAX_CEffectParameters::Controller | ( |  | ) | const

`const` access to the Effect controller

## ◆ Transport() [1/2]

AAX_ITransport * AAX_CEffectParameters::Transport | ( |  | ) |

Access to the Transport object.

## ◆ Transport() [2/2]

const AAX_ITransport * AAX_CEffectParameters::Transport | ( |  | ) | const

`const` access to the Transport object

## ◆ AutomationDelegate() [1/2]

AAX_IAutomationDelegate * AAX_CEffectParameters::AutomationDelegate | ( |  | ) |

Access to the Effect's automation delegate.

## ◆ AutomationDelegate() [2/2]

const AAX_IAutomationDelegate * AAX_CEffectParameters::AutomationDelegate | ( |  | ) | const

`const` access to the Effect's automation delegate

## ◆ SetTaperDelegate()

AAX_Result AAX_CEffectParameters::SetTaperDelegate | ( | AAX_CParamID | iParameterID,
|  | AAX_ITaperDelegateBase & | iTaperDelegate,
|  | bool | iPreserveValue
| ) |  |
| protected

## ◆ SetDisplayDelegate()

AAX_Result AAX_CEffectParameters::SetDisplayDelegate | ( | AAX_CParamID | iParameterID,
|  | AAX_IDisplayDelegateBase & | iDisplayDelegate
| ) |  |
| protected

## ◆ IsParameterTouched()

bool AAX_CEffectParameters::IsParameterTouched | ( | AAX_CParamID | iParameterID | ) | const
| protected

## ◆ IsParameterLinkReady()

bool AAX_CEffectParameters::IsParameterLinkReady | ( | AAX_CParamID | inParameterID,
|  | AAX_EUpdateSource | inSource
| ) |  | const
| protected

## ◆ EffectInit()

virtual AAX_Result AAX_CEffectParameters::EffectInit | ( | void |  | ) |
| inline protected virtual

Initialization helper routine. Called from AAX_CEffectParameters::Initialize.

Override to add parameters, packets, meters, and to do any other custom initialization.

Add custom parameters:

- Create an AAX_CParameter for each parameter in the plug-in
- Call AAX_CParameterManager::AddParameter() using mParameterManager to add parameters to the Parameter Manager

Note
  See bug AAXSDK-897

Register packets:

- Call AAX_CPacketDispatcher::RegisterPacket() using mPacketDispatcher to register a packet and handling callback.

References AAX_SUCCESS.

## ◆ UpdatePageTable() [2/2]

virtual AAX_Result AAX_CEffectParameters::UpdatePageTable | ( | uint32_t | ,
|  | int32_t | ,
|  | AAX_IPageTable & |
| ) |  | const
| inline protected virtual

Protected overload of UpdatePageTable()

Override this version of the method for convenience. This allows the default UpdatePageTable() implementation to handle the interface conversion from IACFUnknown to AAX_IPageTable.

Returns
  This method should return AAX_ERROR_UNIMPLEMENTED if the plug-in does not implement it or when no change is made by the plug-in. This allows optimizations to be used in the host when no UI update is required following this call.

References AAX_ERROR_UNIMPLEMENTED.

## ◆ FilterParameterIDOnSave()

void AAX_CEffectParameters::FilterParameterIDOnSave | ( | AAX_CParamID | controlID | ) |
| protected

CALL: Indicates the indices of parameters that should not be saved in the default AAX_CEffectParameters chunk.

Allows specific parameters to filtered out of the default AAX_CEffectParameters "Save Settings" functionality. This call is automatically invoked on the Master Bypass control when specified by the DefineMasterBypassControlIndex() call.

Parameters

  [in] | controlID | The ID of the parameter that should be removed from the default chunk

## ◆ BuildChunkData()

void AAX_CEffectParameters::BuildChunkData | ( | void |  | ) | const
| protected

Clears out the current chunk in Chunk Parser and adds all of the new values. Used by default implementations of GetChunk() and GetChunkSize().

## Member Data Documentation

## ◆ mNumPlugInChanges

int32_t AAX_CEffectParameters::mNumPlugInChanges
| protected

## ◆ mChunkSize

int32_t AAX_CEffectParameters::mChunkSize
| mutable protected

## ◆ mChunkParser

AAX_CChunkDataParser AAX_CEffectParameters::mChunkParser
| mutable protected

## ◆ mNumChunkedParameters

int32_t AAX_CEffectParameters::mNumChunkedParameters
| protected

## ◆ mPacketDispatcher

AAX_CPacketDispatcher AAX_CEffectParameters::mPacketDispatcher
| protected

## ◆ mParameterManager

AAX_CParameterManager AAX_CEffectParameters::mParameterManager
| protected

Referenced by AAX_CMonolithicParameters::UpdateParameterNormalizedValue().

## ◆ mFilteredParameters

std::set<std::string> AAX_CEffectParameters::mFilteredParameters
| protected

The documentation for this class was generated from the following file:

- AAX_CEffectParameters.h